﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using ThinkGeo.MapSuite.DesktopEdition;
using ThinkGeo.MapSuite.Core;
using System.Diagnostics;

namespace DatabaseToMap
{
    public partial class Form1 : Form
    {

        private static string conn = @"Data Source=EMGS-DHITE\SQLEXPRESS_1;Initial Catalog=SpatialDb;Integrated Security=True;Connect Timeout=15;Encrypt=False;TrustServerCertificate=False;ApplicationIntent=ReadWrite;MultiSubnetFailover=False";
        public Form1()
        {
            InitializeComponent();

            winformsMap1.MapUnit = GeographyUnit.Meter;
            LayerOverlay lo = new LayerOverlay();
            lo.Name = "DbOverlay";
            winformsMap1.Overlays.Add("DbOverlay", lo);
        }

        private void button1_Click(object sender, EventArgs e)
        {
            MsSql2008FeatureLayer db = new MsSql2008FeatureLayer(conn, "Shape", "FeatureId");            
            db.Srid = 32516;
            db.Open();
            int count = db.FeatureSource.GetCount() + 1;
            db.EditTools.BeginTransaction();
            db.EditTools.Add(new Feature(new PointShape(500, 2000), new List<string>() { "Id:" + count }));
            db.EditTools.CommitTransaction();
            db.Close();

            db.Open();
            foreach (Feature feature in db.FeatureSource.GetAllFeatures(ReturningColumnsType.NoColumns))
            {
                PointShape pt = new PointShape(feature.GetWellKnownBinary());
                foreach (KeyValuePair<string, string> col in feature.ColumnValues)
                {
                    Debug.Print(string.Format("Point {0}, {1}, column {2}={3}", pt.X, pt.Y, col.Key, col.Value));
                }

            }


        }

        private void button2_Click(object sender, EventArgs e)
        {
            MsSql2008FeatureLayer db = new MsSql2008FeatureLayer(conn, "Shape", "FeatureId");

            db.ZoomLevelSet.ZoomLevel01.DefaultPointStyle = new PointStyle(PointSymbolType.Circle, 
                new GeoSolidBrush(GeoColor.StandardColors.Red), 10);
            db.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;
            db.Name = "test";
            ((LayerOverlay)winformsMap1.Overlays[0]).Layers.Add("test", db);

            db.Open();
            foreach (Feature feature in db.FeatureSource.GetAllFeatures(ReturningColumnsType.AllColumns))
            {
                PointShape pt = new PointShape(feature.GetWellKnownBinary());
                foreach (KeyValuePair<string, string> col in feature.ColumnValues)
	            {
                    Debug.Print(string.Format("Point {0}, {1}, column {2}={3}",pt.X, pt.Y, col.Key, col.Value));
	            }
                
            }

            RectangleShape rect = db.GetBoundingBox();
            db.Close();

            winformsMap1.CurrentExtent = rect;
            winformsMap1.Refresh();

        }
    }
}
